CREATE OR REPLACE VIEW V_BERTH_OWNER AS (
SELECT BO.ID, BO.ID_PRIVEZ, BO.ID_LASTNIKA, BO.DATE_FROM, BO.DATE_TO, BO.DATE_CREATED, BO.USER_CREATED, BO.DATE_CHANGED, BO.USER_CHANGED, BO.STATUS, BO."COMMENT", BO.TYPE,
BOT.OPIS AS BERTH_OWNER_TYPE_OPIS, BOT.INTERNI_OPIS AS BERTH_OWNER_TYPE_INTERNI_OPIS, 
NP.OBJEKT AS NNPRIVEZ_OBJEKT, NP.N_PRIVEZA AS NNPRIVEZ_N_PRIVEZA, NP.SORT AS NNPRIVEZ_SORT, NP.SORT_PRIKAZ AS NNPRIVEZ_SORT_PRIKAZ, PO.NAZIV AS NNPOMOL_NAZIV, PO.NNLOCATION_ID,
K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK
FROM BERTH_OWNER BO
LEFT OUTER JOIN BERTH_OWNER_TYPE BOT ON BOT.ID = BO.TYPE
LEFT OUTER JOIN NNPRIVEZ NP ON NP.ID_PRIVEZ = BO.ID_PRIVEZ
LEFT OUTER JOIN NNPOMOL PO ON PO.SIFRA = NP.KATEGORIJA
LEFT OUTER JOIN KUPCI K ON K.ID = BO.ID_LASTNIKA
);

CREATE OR REPLACE VIEW V_BERTH_SUBLEASE AS (
SELECT BS.ID, BS.ID_PRIVEZ, BS.ID_LASTNIKA, BS.ID_CARDS, BS.DATE_FROM, BS.DATE_TO, BS.DATE_CREATED, BS.USER_CREATED, BS.DATE_CHANGED, BS.USER_CHANGED,
NP.OBJEKT AS NNPRIVEZ_OBJEKT, NP.N_PRIVEZA AS NNPRIVEZ_N_PRIVEZA, NP.SORT AS NNPRIVEZ_SORT, NP.SORT_PRIKAZ AS NNPRIVEZ_SORT_PRIKAZ, NP.SUBLEASE AS NNPRIVEZ_SUBLEASE, 
(CASE WHEN NP.ID_BERTH_SUBLEASE = BS.ID AND NP.SUBLEASE = 'Y' THEN 'Y' ELSE 'N' END) AS SUBLEASE_ACTIVE, PO.NAZIV AS NNPOMOL_NAZIV, PO.NNLOCATION_ID,
K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, NC.OPIS AS NNCARDS_OPIS
FROM BERTH_SUBLEASE BS
LEFT OUTER JOIN NNPRIVEZ NP ON NP.ID_PRIVEZ = BS.ID_PRIVEZ
LEFT OUTER JOIN NNPOMOL PO ON PO.SIFRA = NP.KATEGORIJA
LEFT OUTER JOIN KUPCI K ON K.ID = BS.ID_LASTNIKA
LEFT OUTER JOIN NNCARDS NC ON NC.ID_CARDS = BS.ID_CARDS
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1334, SYSDATE, '5.5', 1254, 'Berth owner lokacija')
;