ALTER TABLE KNJIZBE
  ADD NNLOCATION_ID NUMBER
;

UPDATE NNATRIBUTI 
SET ACTIVE='N'
WHERE  SIFRA IN ('COR', 'EF1', 'EF2', 'MF1', 'MF2', 'REN', 'FBM', 'BUL', 'AGM', 'AGX', 'HBE', 
'HMO', 'HHS', 'HDS', 'ABS', 'VOT', 'COM', 'TMO', 'INS', 'NOM', 'GRP', 'DEP', 'APF', 'PRS', 'CON', 'ACS')
;

UPDATE SIFRANT 
SET PRIVZETA_VR='PURCHASE'
WHERE STRINGTABLE='NNATRIBUTI' AND ID_STRING='TIP'
;

INSERT INTO SIFRANT (STRINGTABLE, ID_STRING, KODA_SIFRANT, ID_STR_LABEL, NAZIV_SIFRANT, PRIVZETA_VR, INTERNI_OPIS) 
VALUES ('NNATRIBUTI', 'TIP', 'PURCHASE', 'Type', 'Purchase', 'PURCHASE', 'Purchase')
;
INSERT INTO SIFRANT (STRINGTABLE, ID_STRING, KODA_SIFRANT, ID_STR_LABEL, NAZIV_SIFRANT, PRIVZETA_VR, INTERNI_OPIS) 
VALUES ('NNATRIBUTI', 'TIP', 'RESERVATION', 'Type', 'Reservation', 'PURCHASE', 'Reservation')
;

ALTER TABLE NNATRIBUTI
ADD EVALUATE VARCHAR2(10 CHAR)
;

INSERT INTO NNATRIBUTI (SIFRA, OPIS, INTERNI_OPIS, TIP, EVALUATE, ACTIVE)
VALUES
('PUV', 'Purchase by value', 'Purchase by value', 'PURCHASE', 'VALUE', 'Y')
;

INSERT INTO NNATRIBUTI (SIFRA, OPIS, INTERNI_OPIS, TIP, EVALUATE, ACTIVE)
VALUES
('PUQ', 'Purchase by quantity', 'Purchase by quantity', 'PURCHASE', 'QUANTITY', 'Y')
;

INSERT INTO NNATRIBUTI (SIFRA, OPIS, INTERNI_OPIS, TIP, EVALUATE, ACTIVE)
VALUES
('REZ', 'Reservation days', 'Reservation days', 'RESERVATION', 'QUANTITY', 'Y')
;

ALTER TABLE NNVRSKUP_ATRIBUTI
 ADD MANDATORY VARCHAR2(1 CHAR) DEFAULT 'Y' 
;

ALTER TABLE NNVRSKUP_ATRIBUTI
ADD ACTIVE VARCHAR2(1 CHAR) DEFAULT 'Y'
;

ALTER TABLE NNVRSKUP_ATRIBUTI
ADD TYPE_COMPARE VARCHAR2(20 CHAR)
;

INSERT INTO SIFRANT (STRINGTABLE, ID_STRING, KODA_SIFRANT, ID_STR_LABEL, NAZIV_SIFRANT, PRIVZETA_VR, INTERNI_OPIS) 
VALUES ('NNVRSKUP_ATRIBUTI', 'TYPE_COMPARE', 'SERVICE_Q', 'Compare type', 'Service quantity', 'SERVICE_V', 'Service quantity')
; 
INSERT INTO SIFRANT (STRINGTABLE, ID_STRING, KODA_SIFRANT, ID_STR_LABEL, NAZIV_SIFRANT, PRIVZETA_VR, INTERNI_OPIS) 
VALUES ('NNVRSKUP_ATRIBUTI', 'TYPE_COMPARE', 'SERVICE_V', 'Compare type', 'Service value', 'SERVICE_V', 'Service value')
; 
INSERT INTO SIFRANT (STRINGTABLE, ID_STRING, KODA_SIFRANT, ID_STR_LABEL, NAZIV_SIFRANT, PRIVZETA_VR, INTERNI_OPIS) 
VALUES ('NNVRSKUP_ATRIBUTI', 'TYPE_COMPARE', 'PRODUCT_Q', 'Compare type', 'Product quantity', 'SERVICE_V', 'Product quantity')
; 
INSERT INTO SIFRANT (STRINGTABLE, ID_STRING, KODA_SIFRANT, ID_STR_LABEL, NAZIV_SIFRANT, PRIVZETA_VR, INTERNI_OPIS) 
VALUES ('NNVRSKUP_ATRIBUTI', 'TYPE_COMPARE', 'PRODUCT_V', 'Compare type', 'Product value', 'SERVICE_V', 'Product value')
; 
INSERT INTO SIFRANT (STRINGTABLE, ID_STRING, KODA_SIFRANT, ID_STR_LABEL, NAZIV_SIFRANT, PRIVZETA_VR, INTERNI_OPIS) 
VALUES ('NNVRSKUP_ATRIBUTI', 'TYPE_COMPARE', 'GROUP_V', 'Compare type', 'Product group value', 'SERVICE_V', 'Product group value')
; 
INSERT INTO SIFRANT (STRINGTABLE, ID_STRING, KODA_SIFRANT, ID_STR_LABEL, NAZIV_SIFRANT, PRIVZETA_VR, INTERNI_OPIS) 
VALUES ('NNVRSKUP_ATRIBUTI', 'TYPE_COMPARE', 'RESERVTION_Q', 'Compare type', 'Reservation quantity', 'SERVICE_V', 'Reservation quantity')
; 

ALTER TABLE NNVRSKUP_ATRIBUTI
ADD COMPARE_ID VARCHAR2(20 CHAR)
;

CREATE TABLE LOYALTY(
ID_LOYALTY NUMBER NOT NULL,
DATE_CREATE DATE,
ID_LASTNIKA NUMBER NOT NULL,
ID_STORITVE NUMBER,
STORITEV VARCHAR2(20 CHAR),
ID_OBRACUN NUMBER,
ID_ARTIKEL NUMBER,
ID_GRUPE VARCHAR2(50 CHAR),
ID_REZERVATION NUMBER,
LOYALTY_QUANTITY NUMBER NOT NULL,
LOYALTY_VALUE NUMBER NOT NULL,
CONSTRAINT PK_LOYALTY PRIMARY KEY (ID_LOYALTY)
)
;

CREATE SEQUENCE LOYALTY_SEQ MINVALUE 1 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE
;

ALTER TABLE KUPCI
ADD LOYALTY VARCHAR2(1 CHAR)
;

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1389, SYSDATE, '5.5', 1309, 'Loyalty')
;