DROP VIEW V_KUPCI_PLOVILA;

CREATE OR REPLACE VIEW V_KUPCI_PLOVILA AS (
  SELECT CONCAT(CONCAT(K.ID, '-'), P.ID) AS KUPCI_PLOVILA_ID, K.ID AS ID_LASTNIKA, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, K.NASLOV AS KUPCI_NASLOV, K.MESTO AS KUPCI_MESTO, K.POSTA AS KUPCI_POSTA, K.VRSTA AS KUPCI_VRSTA,
  K.NDRZAVA AS KUPCI_NDRZAVA, K.EMAIL AS KUPCI_EMAIL, K.TELEFON_1 AS KUPCI_TELEFON_1, K.YACHT_CLUB_ID, K.ID_MEMBER AS KUPCI_ID_MEMBER, K.ACT AS KUPCI_ACT, K.TELEX AS KUPCI_TELEX, K.GSM AS KUPCI_GSM, K.TELEFON_2 AS KUPCI_TELEFON_2, 
  K.DAVCNA_STEVILKA AS KUPCI_DAVCNA_STEVILKA, K.VALUTA_PLACILA AS KUPCI_VALUTA_PLACILA, K.SALDAKONTI_SIT AS KUPCI_SALDAKONTI_SIT, K.SALDAKONTI_DEM AS KUPCI_SALDAKONTI_DEM, K.SALDAKONTI_KOM AS KUPCI_SALDAKONTI_KOM, K.INT_CODE AS KUPCI_INT_CODE,
  K.VEHICLE_REGISTRATION_NUM AS KUPCI_VEHICLE_REGISTRATION_NUM, K.MANAGER AS KUPCI_MANAGER, 
 (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER,
  P.ID AS PLOVILA_ID, P.IME AS PLOVILA_IME, P.REGISTRSKA_N AS PLOVILA_REGISTRSKA_N, P.MODEL AS PLOVILA_MODEL, P.NTIP AS PLOVILA_NTIP, P.NZASTAVA AS PLOVILA_NZASTAVA, P.TRENUTNO_DO, P.POGODBA_DO, P.DOLZINA AS PLOVILA_DOLZINA, 
  P.SIRINA AS PLOVILA_SIRINA, P.GREZ AS PLOVILA_GREZ, P.BOOKING AS PLOVILA_BOOKING, P.ACT AS PLOVILA_ACT,
  CASE WHEN BERTH_TEMP.ID_PRIVEZ IS NOT NULL THEN BERTH_TEMP.OBJEKT ELSE P.TRENUTNI_OBJEKT_PRIVEZA END AS TRENUTNI_OBJEKT_PRIVEZA,
  CASE WHEN BERTH_TEMP.ID_PRIVEZ IS NOT NULL THEN BERTH_TEMP.N_PRIVEZA ELSE P.TRENUTNA_N_PRIVEZA END AS TRENUTNA_N_PRIVEZA,
  CASE WHEN BERTH_CONTRACT.ID_PRIVEZ IS NOT NULL THEN BERTH_CONTRACT.OBJEKT ELSE P.POGODBENI_OBJEKT_PRIVEZA END AS POGODBENI_OBJEKT_PRIVEZA,
  CASE WHEN BERTH_CONTRACT.ID_PRIVEZ IS NOT NULL THEN BERTH_CONTRACT.N_PRIVEZA ELSE P.POGODBENA_N_PRIVEZA END AS POGODBENA_N_PRIVEZA,
  NNUSR.USER_ AS KUPCI_MANAGER_USER, VPT.ID_PRIVEZ AS ID_PRIVEZ_TEMP, VPT.NNLOCATION_ID AS ID_LOCATION_TEMP, VPC.ID_PRIVEZ AS ID_PRIVEZ_CONTRACT, VPC.NNLOCATION_ID AS ID_LOCATION_CONTRACT
  FROM KUPCI K
  LEFT OUTER JOIN PLOVILA P ON P.ID_LASTNIKA = K.ID
  LEFT OUTER JOIN NUSER NNUSR ON K.MANAGER = NNUSR.NUSER
  LEFT OUTER JOIN (SELECT PRIVEZI.*, RANK() OVER (PARTITION BY ID_PLOVILA ORDER BY ID_PRIVEZI ASC) RNK FROM PRIVEZI WHERE ID_POGODBE IS NULL) PRIVEZI_TEMP ON (PRIVEZI_TEMP.ID_PLOVILA = P.ID AND PRIVEZI_TEMP.RNK = 1)
  LEFT OUTER JOIN NNPRIVEZ BERTH_TEMP ON BERTH_TEMP.ID_PRIVEZ = PRIVEZI_TEMP.ID_PRIVEZ
  LEFT OUTER JOIN (SELECT PRIVEZI.*, RANK() OVER (PARTITION BY ID_PLOVILA ORDER BY ID_PRIVEZI DESC) RNK FROM PRIVEZI WHERE ID_POGODBE IS NOT NULL) PRIVEZI_CONTRACT ON (PRIVEZI_CONTRACT.ID_PLOVILA = P.ID AND PRIVEZI_CONTRACT.RNK = 1)
  LEFT OUTER JOIN NNPRIVEZ BERTH_CONTRACT ON BERTH_CONTRACT.ID_PRIVEZ = PRIVEZI_CONTRACT.ID_PRIVEZ
  LEFT OUTER JOIN V_PRIVEZ_LOCATION VPT ON VPT.ID_PRIVEZ = BERTH_TEMP.ID_PRIVEZ
  LEFT OUTER JOIN V_PRIVEZ_LOCATION VPC ON VPC.ID_PRIVEZ = BERTH_CONTRACT.ID_PRIVEZ
);

DROP VIEW V_PLOVILA;

CREATE OR REPLACE VIEW V_PLOVILA AS (
SELECT P.ID, P.ID_LASTNIKA, P.N_POGODBE, P.FEKALNI_TANK, P.NTIP, P.IME, P.MATICNA_LUKA, P.REGISTRSKA_N, P.NZASTAVA, P.DOLZINA, P.SIRINA, P.VISINA, P.TEZA, P.GREZ, P.PODSTAVEK, P.VALUTA, P.VREDNOST,
P.PROIZVAJALEC, P.LETO_IZDELAVE, P.KONSTRUKCIJSKI_MATERIAL, P.TIP_MOTORJA, P.MOC_MOTORJA, P.ENOTA_MOCI_MOTORJA, P.STEVILO_MOTORJEV, P.N_MOTORJA_1, P.N_MOTORJA_2, P.N_MOTORJA_3, P.ZAVAROVALNICA,
P.N_ZAVAROVALNE_POLICE, P.ZAVAROVANO_DO, P.ZAVAROVALNA_VSOTA, P.VALUTA_ZAVAROVALNE_VSOTE, P.BELEZKA, P.BELEZKA_2, P.POGODBA_OD, P.POGODBA_DO,P.TRENUTNO_OD, P.TRENUTNO_DO, P.PLOVNO_DOVOLJENJE, 
P.KRAJ_PLOVNEGA_DOVOLJENJA, P.DATUM_PLOVNEGA_DOVOLJENJA, P.N_DELOVNEGA_NALOGA, P.STORITVE,
P.USER_KREIRANJA, P.DATUM_KREIRANJA, P.USER_SPREMEMBE, P.DATUM_SPREMEMBE, P.N_ZIMOVANJE, P.DATUM_PREK_ZIMOVANJA, P.BOOKING, P.STEVILO_KABIN, P.MODEL, P.STEVILO_LEZISC, P.GORIVO, P.MOC_MOTORJA_1,
P.MOC_MOTORJA_2, P.ID_TIPA_MOTORJA_1, P.ID_TIPA_MOTORJA_2, P.ID_TIPA_MOTORJA_3, P.ENOTA_MOCI_MOTORJA_1, P.ENOTA_MOCI_MOTORJA_2, P.ENOTA_MOCI_MOTORJA_3, P.ID_PROIZVAJALCA, P.ID_KONSTR_MAT,
P.ID_PODSTAVKA, P.ID_TIPA, P.TIP_PLOVILA, P.DAT_PLOV_DOV, P.DATUM_ZAVAROVANJE, P.POOBLASTILO_DO, P.VPIS_LIST_DO, P.DATUM_MENJ_OLJA, P.DATUM_RED_SERVIS, P.ST_UR_MOTORJA, P.PROVIZIJA_DELITEV,
P.KASKO_ZAVAROVANJE_DO, P.PROVIZIJA, P.OCISCENA, P.RFID, P.PODALJSA, P.DOVOLJENJE, P.LASTNISTVO, P.ID_PLOVILA_CARINA, P.ACT, P.PLOVILA_IZVOR, P.RFIDSIGNAL, P.LAST_PORT, P.COLOR, P.ID_PRIVEZ, 
P.PROPULSION_TYPE, P.PAYMENT_TYPE, P.UNDERWATER_HULL, P.TOP_SIDES, P.DECK, P.SUPER_STRUCTURE, P.SURFACE, P.HULL_ID_NUMBER, P.VRSKUP, P.KUPCI_CREDIT_CARD_ID, P.BOAT_PRICE, P.BRUTO_TEZA, 
P.ST_POTNIKOV, P.LOADING_WEIGHT, P.LOADING_VOLUME,
NT.OPIS AS NNTIP_OPIS, NT.INTERNI_OPIS AS NNTIP_INTERNI_OPIS, ND.OPIS AS NNDRZAVE_OPIS, ND.INTERNI_OPIS AS NNDRZAVE_INTERNI_OPIS, NVK.OPIS AS NNVRSKUP_OPIS, NVK.INTERNI_OPIS AS NNVRSKUP_INTERNI_OPIS,
BERTH_TEMP.ID_PRIVEZ AS TRENUTNI_ID_PRIVEZA,
CASE WHEN BERTH_TEMP.ID_PRIVEZ IS NOT NULL THEN BERTH_TEMP.OBJEKT ELSE P.TRENUTNI_OBJEKT_PRIVEZA END AS TRENUTNI_OBJEKT_PRIVEZA,
CASE WHEN BERTH_TEMP.ID_PRIVEZ IS NOT NULL THEN BERTH_TEMP.N_PRIVEZA ELSE P.TRENUTNA_N_PRIVEZA END AS TRENUTNA_N_PRIVEZA,
CASE WHEN BERTH_CONTRACT.ID_PRIVEZ IS NOT NULL THEN BERTH_CONTRACT.OBJEKT ELSE P.POGODBENI_OBJEKT_PRIVEZA END AS POGODBENI_OBJEKT_PRIVEZA,
CASE WHEN BERTH_CONTRACT.ID_PRIVEZ IS NOT NULL THEN BERTH_CONTRACT.N_PRIVEZA ELSE P.POGODBENA_N_PRIVEZA END AS POGODBENA_N_PRIVEZA,
CASE WHEN (P.TRENUTNI_OBJEKT_PRIVEZA IS NOT NULL AND P.TRENUTNA_N_PRIVEZA IS NOT NULL AND UPPER(P.TRENUTNA_N_PRIVEZA) <> (SELECT UPPER(VREDNOST) FROM S_NASTAVITVE WHERE NAZIV = 'StartIzhod')) THEN 'Y' ELSE 'N' END AS IN_MARINA,
CASE WHEN (UPPER(P.TRENUTNA_N_PRIVEZA) = (SELECT UPPER(VREDNOST) FROM S_NASTAVITVE WHERE NAZIV = 'StartIzhod')) THEN 'Y' ELSE 'N' END AS ON_TEMPORARY_EXIT
FROM PLOVILA P
LEFT OUTER JOIN NNTIP NT ON NT.SIFRA = P.NTIP
LEFT OUTER JOIN NNDRZAVE ND ON ND.SIFRA = P.NZASTAVA
LEFT OUTER JOIN NNVRSKUP NVK ON NVK.SIFRA = P.VRSKUP
LEFT OUTER JOIN (SELECT PRIVEZI.*, RANK() OVER (PARTITION BY ID_PLOVILA ORDER BY ID_PRIVEZI ASC) RNK FROM PRIVEZI WHERE ID_POGODBE IS NULL) PRIVEZI_TEMP ON (PRIVEZI_TEMP.ID_PLOVILA = P.ID AND PRIVEZI_TEMP.RNK = 1)
LEFT OUTER JOIN NNPRIVEZ BERTH_TEMP ON BERTH_TEMP.ID_PRIVEZ = PRIVEZI_TEMP.ID_PRIVEZ
LEFT OUTER JOIN (SELECT PRIVEZI.*, RANK() OVER (PARTITION BY ID_PLOVILA ORDER BY ID_PRIVEZI DESC) RNK FROM PRIVEZI WHERE ID_POGODBE IS NOT NULL) PRIVEZI_CONTRACT ON (PRIVEZI_CONTRACT.ID_PLOVILA = P.ID AND PRIVEZI_CONTRACT.RNK = 1)
LEFT OUTER JOIN NNPRIVEZ BERTH_CONTRACT ON BERTH_CONTRACT.ID_PRIVEZ = PRIVEZI_CONTRACT.ID_PRIVEZ
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1432, SYSDATE, '5.5', 1352, 'Plovila privezi')
;