ALTER TABLE S_ARTIKLI
ADD AUTO_NOTE VARCHAR2(1 CHAR);

DROP VIEW V_FB_VIEW_PRODUCT;

CREATE OR REPLACE VIEW V_FB_VIEW_PRODUCT AS (
SELECT FP.ID_FB_VIEW_PRODUCT, FP.ID_FB_VIEW_GROUP, FP.ID_ARTIKEL, FP.SORT, FP.COLOR,
FG.ID_FB_LOCATION, FG.DESCRIPTION AS GROUP_DESCRIPTION, FG.ACTIVE AS GROUP_ACTIVE, S.NAZIV1 AS PRODUCT_DESCRIPTION, S.AUTO_NOTE AS PRODUCT_AUTO_NOTE
FROM FB_VIEW_PRODUCT FP
LEFT OUTER JOIN FB_VIEW_GROUP FG ON FG.ID_FB_VIEW_GROUP = FP.ID_FB_VIEW_GROUP
LEFT OUTER JOIN S_ARTIKLI S ON S.ID_ARTIKEL = FP.ID_ARTIKEL
);

DROP VIEW V_S_ARTIKLI;

CREATE OR REPLACE VIEW V_S_ARTIKLI
AS (
SELECT SA.ID_ARTIKEL, SA.ID_ENOTA, SA.ID_DAVEK, SA.ID_GRUPA, SA.NAZIV, SA.NAZIV1, SA.BAR_KODA, SA.MIN_ZALOGA, SA.MIN_IZDAJA, SA.CENA_SKL, SA.CENA_MP, SA.CENA_VP, SA.CENA_DEM, SA.DT_VPISA,
SA.DOBAVITELJ, SA.UPOR_VPIS, SA.UPOR_SPREM, SA.DAV_STOPNJA, SA.DT_SPREMEMBE, SA.KONTO, SA.LOKACIJA, SA.SIFRA_DOB, SA.V_UPORABI, SA.PRENOS, SA.LOKACIJA1, SA.LOKACIJA2, SA.CENAZDDV, SA.VRSTA,
SA.INTERNI_OPIS, SA.PROIZVAJALEC, SA.NNLOCATION_ID, SA.SALE, SA.STOCKS, SA.RECIPE, SA.FB, SA.PORTAL, SA.DESCRIPTION, SA.AUTO_NOTE,
SE.NAZIV AS S_ENOTE_NAZIV, SE.OSN_ENOTA AS S_ENOTE_OSN_ENOTA, SD.OPIS AS S_DAVEK_OPIS, SG.NAZIV AS S_GRUPE_NAZIV, SG.SERVICE AS S_GRUPE_SERVICE, 
SG.COMMISSION_PERCENTAGE AS S_GRUPE_COMMISSION_PERCENTAGE, SG.OWNER_TYPE AS S_GRUPE_OWNER_TYPE, SG.ROUNDING AS S_GRUPE_ROUNDING
FROM S_ARTIKLI SA
LEFT OUTER JOIN S_DAVEK SD ON SD.ID_DAVEK = SA.ID_DAVEK
LEFT OUTER JOIN S_ENOTE SE ON SE.ID_ENOTA = SA.ID_ENOTA
LEFT OUTER JOIN S_GRUPE SG ON SG.ID_GRUPA = SA.ID_GRUPA
);

DROP VIEW V_RESERVATION;

CREATE OR REPLACE VIEW V_RESERVATION AS (
  SELECT RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, RE.STATUS_REZERVAC, RE.KOMENTAR, RE.DATUM_REZERVACIJE, RE.DATUM_DO, RE.PRIVEZ, RE.ID_PRIVEZ, RE.ODPOVED, RE.HOURLY, RE.CHECKIN_STATUS, RE.CHECKIN_TIME, RE.CHECKOUT_TIME,
  NNPR.NNLOCATION_ID, DE.ID_REZERVAC_DETAIL AS REZERVAC_DETAIL_ID, DE.DATUM_OD AS REZERVAC_DETAIL_DATUM_OD, DE.DATUM_DO AS REZERVAC_DETAIL_DATUM_DO, DE.STATUS_REZERVAC AS REZERVAC_DETAIL_STATUS, DE.COMPLETE AS REZERVAC_DETAIL_COMPLETE,
  DE.TIME_FROM AS REZERVAC_DETAIL_TIME_FROM, DE.TIME_TO AS REZERVAC_DETAIL_TIME_TO, NNR.OBJEKT AS REZERVAC_PRIVEZ_OBJEKT, NNR.KATEGORIJA AS REZERVAC_PRIVEZ_KATEGORIJA,
  NND.N_PRIVEZA AS REZERVAC_DETAIL_PRIVEZ, NND.ID_PRIVEZ AS REZERVAC_DETAIL_ID_PRIVEZ, NND.OCCUPANCY_STATISTICS AS REZERVAC_DETAIL_OCC_STAT, NNPD.NNLOCATION_ID AS REZERVAC_DETAIL_NNLOCATION_ID, 
  KU.IME AS KUPCI_IME, KU.PRIIMEK AS KUPCI_PRIIMEK,
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
  THEN ((CASE WHEN RE.STATUS_REZERVAC IN ( 0, -1, 1, 2, -10) AND DE.DATUM_DO IS NOT NULL AND DE.TIME_TO IS NOT NULL AND TRUNC(DE.TIME_TO) <> DE.TIME_TO THEN DE.DATUM_DO - 1 ELSE DE.DATUM_DO END)) 
  ELSE DE.DATUM_DO END) AS REZERVAC_DETAIL_CALC_DATE_TO,
  (CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (KU.IME || ' ' || KU.PRIIMEK) ELSE (KU.PRIIMEK || ' ' || KU.IME) END) END) AS OWNER,
  (CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
  (CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
  (CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
  (CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
  (CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
  (CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA,
  (CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DATUM_ZAVAROVANJE ELSE PL.DATUM_ZAVAROVANJE END) AS DATUM_ZAVAROVANJE,
  (CASE WHEN RE.STATUS_REZERVAC IN (0, 1, 2) THEN 'Y' ELSE 'N' END) AS RECEIVED,
  (CASE WHEN RE.STATUS_REZERVAC = 0 THEN 'Y' ELSE 'N' END) AS DEPARTED
  FROM REZERVAC RE
  JOIN REZERVAC_DETAIL DE ON RE.ID = DE.ID_REZERVAC
  LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
  LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
  LEFT OUTER JOIN NNPRIVEZ NND ON NND.ID_PRIVEZ = DE.ID_PRIVEZ
  LEFT OUTER JOIN NNPOMOL NNPD ON NNPD.SIFRA = NND.KATEGORIJA
  LEFT OUTER JOIN NNPRIVEZ NNR ON NNR.ID_PRIVEZ = RE.ID_PRIVEZ
  LEFT OUTER JOIN NNPOMOL NNPR ON NNPR.SIFRA = NNR.KATEGORIJA
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1836, SYSDATE, '5.5', 1756, 'FB additions')
;
