-- Popravek privzetih vrednosti šifranta za tabelo NNOBJEKT in OBJECT_TYPE na SEA
UPDATE SIFRANT
SET PRIVZETA_VR = 'SEA'
WHERE STRINGTABLE = 'NNOBJEKT'
AND ID_STRING = 'OBJECT_TYPE';

-- Dodajanje novega tipa NNTIP_TYPE za tabelo NNTIP
ALTER TABLE NNTIP
ADD NNTIP_TYPE VARCHAR2(10 CHAR);

-- Definiranje NNTIP_TYPE in že znanih vrednosti za tip plovila
UPDATE NNTIP 
SET NNTIP_TYPE='YACHT'
WHERE (NNTIP_TYPE IS NULL) AND ( (SIFRA IN ('J')) OR (UPPER(INTERNI_OPIS)='YACHT'  OR (UPPER(OPIS)='YACHT')) );

UPDATE NNTIP 
SET NNTIP_TYPE='SAILBOAT'
WHERE (NNTIP_TYPE IS NULL) AND ( (SIFRA IN ('JD')) OR (UPPER(INTERNI_OPIS)='SAILBOAT'  OR (UPPER(OPIS)='SAILBOAT')) );

UPDATE NNTIP 
SET NNTIP_TYPE='CATAMARAN'
WHERE (NNTIP_TYPE IS NULL) AND ( (SIFRA IN ('KA')) OR (UPPER(INTERNI_OPIS)='CATAMARAN'  OR (UPPER(OPIS)='CATAMARAN')) );

UPDATE NNTIP 
SET NNTIP_TYPE='W_SCOOTER'
WHERE (NNTIP_TYPE IS NULL) AND ( (SIFRA IN ('S')) OR (UPPER(INTERNI_OPIS)='W. SCOOTER'  OR (UPPER(OPIS)='W. SCOOTER')) );

UPDATE NNTIP 
SET NNTIP_TYPE='INFL_BOAT'
WHERE (NNTIP_TYPE IS NULL) AND ( (SIFRA IN ('GU')) OR (UPPER(INTERNI_OPIS)='INFL. BOAT'  OR (UPPER(OPIS)='INFL. BOAT')) );

UPDATE NNTIP 
SET NNTIP_TYPE='SPEED_BOAT'
WHERE (NNTIP_TYPE IS NULL) AND ( (SIFRA IN ('G')) OR (UPPER(INTERNI_OPIS)='SPEED BOAT'  OR (UPPER(OPIS)='SPEED BOAT')) );

-- Vstavljanje novih tipov za tabelo NNTIP (NNTIP_TYPE), da se lahko v kodi sklicujemo na konstante
INSERT INTO SIFRANT (STRINGTABLE, ID_STRING, KODA_SIFRANT, ID_STR_LABEL, NAZIV_SIFRANT, PRIVZETA_VR, INTERNI_OPIS) 
VALUES ('NNTIP', 'NNTIP_TYPE', 'SAILBOAT', 'SAILBOAT', 'SAILBOAT', 'SAILBOAT', 'SAILBOAT');

INSERT INTO SIFRANT (STRINGTABLE, ID_STRING, KODA_SIFRANT, ID_STR_LABEL, NAZIV_SIFRANT, PRIVZETA_VR, INTERNI_OPIS) 
VALUES ('NNTIP', 'NNTIP_TYPE', 'YACHT', 'YACHT', 'YACHT', 'SAILBOAT', 'YACHT');

INSERT INTO SIFRANT (STRINGTABLE, ID_STRING, KODA_SIFRANT, ID_STR_LABEL, NAZIV_SIFRANT, PRIVZETA_VR, INTERNI_OPIS) 
VALUES ('NNTIP', 'NNTIP_TYPE', 'CATAMARAN', 'CATAMARAN', 'CATAMARAN', 'SAILBOAT', 'CATAMARAN');

INSERT INTO SIFRANT (STRINGTABLE, ID_STRING, KODA_SIFRANT, ID_STR_LABEL, NAZIV_SIFRANT, PRIVZETA_VR, INTERNI_OPIS) 
VALUES ('NNTIP', 'NNTIP_TYPE', 'W_SCOOTER', 'W_SCOOTER', 'W_SCOOTER', 'SAILBOAT', 'W_SCOOTER');

INSERT INTO SIFRANT (STRINGTABLE, ID_STRING, KODA_SIFRANT, ID_STR_LABEL, NAZIV_SIFRANT, PRIVZETA_VR, INTERNI_OPIS) 
VALUES ('NNTIP', 'NNTIP_TYPE', 'INFL_BOAT', 'INFL_BOAT', 'INFL_BOAT', 'SAILBOAT', 'INFL_BOAT');

INSERT INTO SIFRANT (STRINGTABLE, ID_STRING, KODA_SIFRANT, ID_STR_LABEL, NAZIV_SIFRANT, PRIVZETA_VR, INTERNI_OPIS) 
VALUES ('NNTIP', 'NNTIP_TYPE', 'SPEED_BOAT', 'SPEED_BOAT', 'SPEED_BOAT', 'SAILBOAT', 'SPEED_BOAT');

INSERT INTO SIFRANT (STRINGTABLE, ID_STRING, KODA_SIFRANT, ID_STR_LABEL, NAZIV_SIFRANT, PRIVZETA_VR, INTERNI_OPIS) 
VALUES ('NNTIP', 'NNTIP_TYPE', 'HUMAN', 'HUMAN', 'HUMAN', 'SAILBOAT', 'HUMAN');

-- Vstavljanje novih tipov za tabelo NNPOMOL (NNPOMOL_TYPE), da se lahko v kodi sklicujemo na konstante
INSERT INTO SIFRANT (STRINGTABLE, ID_STRING, KODA_SIFRANT, ID_STR_LABEL, NAZIV_SIFRANT, PRIVZETA_VR, INTERNI_OPIS) 
VALUES ('NNPOMOL', 'NNPOMOL_TYPE', 'REGULAR', 'REGULAR', 'REGULAR', 'REGULAR', 'REGULAR');

INSERT INTO SIFRANT (STRINGTABLE, ID_STRING, KODA_SIFRANT, ID_STR_LABEL, NAZIV_SIFRANT, PRIVZETA_VR, INTERNI_OPIS) 
VALUES ('NNPOMOL', 'NNPOMOL_TYPE', 'REGAL', 'REGAL', 'REGAL', 'REGULAR', 'REGAL');

-- Dodajanje stolpcev za definiranje RGB barve objekta priveza in poljubne SVG oblike (top in front pogled)
ALTER TABLE NNOBJEKT
ADD (
  BARVA VARCHAR2(20 CHAR), 
  SVG_OBLIKA_TOP VARCHAR2(2000 CHAR),
  SVG_OBLIKA_FRONT VARCHAR2(2000 CHAR)
);

-- Dodajanje stolpcev za definiranje RGB barve tipa plovila in poljubne SVG oblike (top in front pogled)
ALTER TABLE NNTIP
ADD (
  BARVA VARCHAR2(20 CHAR), 
  SVG_OBLIKA_TOP VARCHAR2(2000 CHAR),
  SVG_OBLIKA_FRONT VARCHAR2(2000 CHAR)
);

-- Dodajanje stolpcev na NNPOMOL, podobno kot za NNOBJEKT in NNTIP
ALTER TABLE NNPOMOL
ADD (
  NNPOMOL_TYPE VARCHAR2(10 CHAR),
  BARVA VARCHAR2(20 CHAR), 
  SVG_OBLIKA_TOP VARCHAR2(2000 CHAR),
  SVG_OBLIKA_FRONT VARCHAR2(2000 CHAR)
);

-- Privzeto so vsi pomoli navadnega tipa REGULAR
UPDATE NNPOMOL
SET NNPOMOL_TYPE = 'REGULAR'
WHERE NNPOMOL_TYPE IS NULL;

-- Popravek pogleda V_PLOVILA, dodan NNOBJEKT.OBJECT_TYPE, NNTIP.NNTIP_TYPE, NNTIP.BARVA, NNTIP.SVG_OBLIKA_TOP, NNTIP.SVG_OBLIKA_FRONT
CREATE OR REPLACE VIEW V_PLOVILA AS (
	SELECT PR.ID_PRIVEZI, PL.ID AS ID_PLOVILA, NVL(TRUNC(PL.TRENUTNO_OD), TRUNC(SYSDATE)) AS DATUM_OD, NVL(TRUNC(PL.TRENUTNO_DO), TRUNC(SYSDATE)+ 1) AS DATUM_DO,
	PR.ID_PRIVEZ, N.OBJEKT, N.N_PRIVEZA, PL.IME AS IME_PLOVILA, PL.NTIP AS TIP_PLOVILA, PL.DOLZINA AS DOLZINA_PLOVILA, PL.SIRINA AS SIRINA_PLOVILA, K.ID AS ID_LASTNIKA, K.IME AS IME_KUPCI, K.PRIIMEK AS PRIIMEK_KUPCI, K.SALDAKONTI_SIT,
	(CASE WHEN PL.POGODBENI_OBJEKT_PRIVEZA IS NOT NULL THEN 'PO' ELSE 'TR' END) AS VRSTA_PLOVILA, PL.REGISTRSKA_N AS REGISTRSKA_N_PLOVILA, NT.OPIS AS TIP_PLOVILA_LONG, PL.NZASTAVA AS NZASTAVA_PLOVILA, ND.OZNAKA AS NZASTAVA_PLOVILA_SHORT, ND.OPIS AS NZASTAVA_PLOVILA_LONG,
	NNO.OBJECT_TYPE, NT.NNTIP_TYPE, NT.BARVA, NT.SVG_OBLIKA_TOP, NT.SVG_OBLIKA_FRONT
	FROM PRIVEZI PR
	JOIN PLOVILA PL ON PL.ID = PR.ID_PLOVILA
	JOIN KUPCI K ON K.ID = PL.ID_LASTNIKA
	JOIN NNPRIVEZ N ON N.ID_PRIVEZ = PR.ID_PRIVEZ
	LEFT OUTER JOIN NNTIP NT ON NT.SIFRA = PL.NTIP
	LEFT OUTER JOIN NNDRZAVE ND ON ND.SIFRA = PL.NZASTAVA
	LEFT OUTER JOIN NNOBJEKT NNO ON NNO.SIFRA = N.OBJEKT
	WHERE PR.ID_POGODBE IS NULL
);

-- Popravek pogleda V_PLOVILA_SVG, dodan NNOBJEKT.OBJECT_TYPE, NNTIP.NNTIP_TYPE, NNTIP.BARVA, NNTIP.SVG_OBLIKA_TOP, NNTIP.SVG_OBLIKA_FRONT
CREATE OR REPLACE VIEW V_PLOVILA_SVG AS (
	SELECT V.ID_PRIVEZI, V.ID_PLOVILA, V.DATUM_OD, V.DATUM_DO, V.ID_PRIVEZ, V.OBJEKT, V.N_PRIVEZA, V.IME_PLOVILA, V.TIP_PLOVILA, V.DOLZINA_PLOVILA, V.SIRINA_PLOVILA, V.ID_LASTNIKA,
	V.IME_KUPCI, V.PRIIMEK_KUPCI, V.SALDAKONTI_SIT, V.VRSTA_PLOVILA,
	PS.TRANS_X AS TRANS_X_PLOVILA, PS.TRANS_Y AS TRANS_Y_PLOVILA, PS.ROT_DEGREES AS ROT_DEGREES_PLOVILA, NS.DOLZINA AS DOLZINA_PRIVEZA, NS.SIRINA AS SIRINA_PRIVEZA, 
	NS.TRANS_X AS TRANS_X_PRIVEZA, NS.TRANS_Y AS TRANS_Y_PRIVEZA, NS.ROT_DEGREES AS ROT_DEGREES_PRIVEZA,
	V.OBJECT_TYPE, V.NNTIP_TYPE, V.BARVA, V.SVG_OBLIKA_TOP, V.SVG_OBLIKA_FRONT
	FROM V_PLOVILA V
	JOIN NNPRIVEZ_SVG NS ON NS.ID_PRIVEZ = V.ID_PRIVEZ
	LEFT JOIN PLOVILA_SVG PS ON PS.ID_PLOVILA = V.ID_PLOVILA
);

-- Osvezevanje pogleda V_NNPRIVEZ_PLOVILA, brez sprememb
CREATE OR REPLACE VIEW V_NNPRIVEZ_PLOVILA AS (
	SELECT DISTINCT NN.ID_PRIVEZ || '-' || V.ID_PRIVEZI AS ID, NN.ID_PRIVEZ, NN.OBJEKT, NN.KATEGORIJA, NN.N_PRIVEZA, NN.DOLZINA, NN.SIRINA, NN.VISINA, NN.GLOBINA, NN.LIMIT, NN.ZASEDENO,
	V.ID_PRIVEZI, V.ID_PLOVILA, V.ID_LASTNIKA, V.DATUM_OD, V.DATUM_DO, V.IME_PLOVILA, V.PRIIMEK_KUPCI, V.IME_KUPCI
	FROM NNPRIVEZ NN
	LEFT OUTER JOIN V_PLOVILA V ON V.ID_PRIVEZ = NN.ID_PRIVEZ
);

-- Popravek pogleda V_REZERVAC, popravljen default TIP_PLOVILA_LONG in NTIP glede na konstanto SAILBOAT
-- dodan NNOBJEKT.OBJECT_TYPE, NNTIP.NNTIP_TYPE, NNTIP.BARVA, NNTIP.SVG_OBLIKA_TOP, NNTIP.SVG_OBLIKA_FRONT
CREATE OR REPLACE VIEW V_REZERVAC AS (
  SELECT R.ID, D.ID_REZERVAC_DETAIL, R.ID_POGODBE, D.DATUM_OD AS DATUM_REZERVACIJE, D.DATUM_DO,
  NP.OBJEKT AS NOBJEKT, NP.N_PRIVEZA AS PRIVEZ, D.ID_PRIVEZ, R.VRSTA, D.STATUS_REZERVAC, R.ID_LASTNIKA, R.ID_PLOVILA, NNO.OBJECT_TYPE, 
  (CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.NAZIV ELSE K.PRIIMEK END) AS NAZIV,
  (CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.PRIIMEK ELSE K.PRIIMEK END) AS PRIIMEK,
  (CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.IME ELSE K.IME END) AS IME, K.SALDAKONTI_SIT,
  (CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.PLOVILO ELSE P.IME END) AS PLOVILO,
  (CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.DOLZINA ELSE P.DOLZINA END) AS DOLZINA,
  (CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.SIRINA ELSE P.SIRINA END) AS SIRINA,
  (CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.GREZ ELSE P.GREZ END) AS GREZ,
  (CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN (SELECT SIFRA FROM NNTIP WHERE NNTIP_TYPE = 'SAILBOAT') ELSE P.NTIP END) AS NTIP,
  (CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN (SELECT OPIS FROM NNTIP WHERE NNTIP_TYPE = 'SAILBOAT') ELSE NT.OPIS END) AS TIP_PLOVILA_LONG,
  (CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN 'SAILBOAT' ELSE NT.NNTIP_TYPE END) AS NNTIP_TYPE,
  (CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN (SELECT BARVA FROM NNTIP WHERE NNTIP_TYPE = 'SAILBOAT') ELSE NT.BARVA END) AS BARVA,
  (CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN (SELECT SVG_OBLIKA_TOP FROM NNTIP WHERE NNTIP_TYPE = 'SAILBOAT') ELSE NT.SVG_OBLIKA_TOP END) AS SVG_OBLIKA_TOP,
  (CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN (SELECT SVG_OBLIKA_FRONT FROM NNTIP WHERE NNTIP_TYPE = 'SAILBOAT') ELSE NT.SVG_OBLIKA_FRONT END) AS SVG_OBLIKA_FRONT
  FROM REZERVAC R
  JOIN REZERVAC_DETAIL D ON R.ID=D.ID_REZERVAC
  LEFT OUTER JOIN NNPRIVEZ NP ON D.ID_PRIVEZ=NP.ID_PRIVEZ
  LEFT OUTER JOIN KUPCI K ON K.ID = R.ID_LASTNIKA
  LEFT OUTER JOIN PLOVILA P ON P.ID = R.ID_PLOVILA
  LEFT OUTER JOIN NNTIP NT ON NT.SIFRA = P.NTIP
  LEFT OUTER JOIN NNOBJEKT NNO ON NNO.SIFRA = NP.OBJEKT
  WHERE R.STORNO IS NULL AND R.DATUM_DO IS NOT NULL
);

-- Popravek pogleda V_REZERVAC_SVG, dodan NNOBJEKT.OBJECT_TYPE, NNTIP.NNTIP_TYPE, NNTIP.BARVA, NNTIP.SVG_OBLIKA_TOP, NNTIP.SVG_OBLIKA_FRONT
CREATE OR REPLACE VIEW V_REZERVAC_SVG AS (
	SELECT DISTINCT V.ID, V.ID_REZERVAC_DETAIL, V.ID_POGODBE, V.DATUM_REZERVACIJE, V.DATUM_DO, V.ID_LASTNIKA, V.ID_PLOVILA, V.ID_PRIVEZ, V.PRIIMEK AS PRIIMEK_LASTNIKA, V.IME AS IME_LASTNIKA,
	V.PLOVILO AS IME_PLOVILA, V.NTIP AS TIP_PLOVILA, V.DOLZINA AS DOLZINA_PLOVILA, V.SIRINA AS SIRINA_PLOVILA, RD.TRANS_X AS TRANS_X_PLOVILA, RD.TRANS_Y AS TRANS_Y_PLOVILA,
	RD.ROT_DEGREES AS ROT_DEGREES_PLOVILA, NS.DOLZINA AS DOLZINA_PRIVEZA, NS.SIRINA AS SIRINA_PRIVEZA, NS.TRANS_X AS TRANS_X_PRIVEZA, NS.TRANS_Y AS TRANS_Y_PRIVEZA, NS.ROT_DEGREES AS ROT_DEGREES_PRIVEZA, N.OBJEKT,
	V.VRSTA AS VRSTA_REZERVACIJE, V.STATUS_REZERVAC AS STATUS_REZERVACIJE, V.OBJECT_TYPE, V.NNTIP_TYPE, V.BARVA, V.SVG_OBLIKA_TOP, V.SVG_OBLIKA_FRONT
	FROM V_REZERVAC V
	JOIN NNPRIVEZ N ON N.ID_PRIVEZ = V.ID_PRIVEZ
	JOIN NNPRIVEZ_SVG NS ON NS.ID_PRIVEZ = V.ID_PRIVEZ
	LEFT JOIN REZERVAC_DETAIL_SVG RD ON RD.ID_REZERVAC_DETAIL = V.ID_REZERVAC_DETAIL
);

-- Osvezevanje pogleda V_NNPRIVEZ_REZERVAC, brez sprememb
CREATE OR REPLACE VIEW V_NNPRIVEZ_REZERVAC AS (
	SELECT DISTINCT NN.ID_PRIVEZ || '-' || VR.ID_REZERVAC_DETAIL AS ID, NN.ID_PRIVEZ, NN.OBJEKT, NN.KATEGORIJA, NN.N_PRIVEZA, NN.DOLZINA, NN.SIRINA, NN.VISINA, NN.GLOBINA, NN.LIMIT, NN.ZASEDENO,
	VR.ID AS ID_REZERVAC, VR.ID_REZERVAC_DETAIL, VR.DATUM_REZERVACIJE, VR.DATUM_DO, VR.PLOVILO AS IME_PLOVILA, VR.PRIIMEK AS PRIIMEK_LASTNIKA, VR.IME AS IME_LASTNIKA
	FROM NNPRIVEZ NN
	LEFT OUTER JOIN V_REZERVAC VR ON VR.ID_PRIVEZ = NN.ID_PRIVEZ
);

insert into verzije_baza (id, dt_vpis, verzija, ver_nr, opis) 
values 
(394, SYSDATE, '5.5', 314, 'Poljubna definicija barv in oblik objektov');