ALTER TABLE DATOTEKE_PLOVIL ADD (ID_DATOTEKE_PLOVIL NUMBER);

CREATE SEQUENCE DATOTEKE_PLOVIL_SEQ MINVALUE 1 MAXVALUE 9999999999999999999999999999 INCREMENT BY 1 START WITH 1 CACHE 20 NOORDER  NOCYCLE;

UPDATE DATOTEKE_PLOVIL 
SET ID_DATOTEKE_PLOVIL = DATOTEKE_PLOVIL_SEQ.NEXTVAL
WHERE ID_DATOTEKE_PLOVIL IS NULL;

ALTER TABLE DATOTEKE_PLOVIL ADD (
CONSTRAINT DATOTEKE_PLOVIL_UNIQUE UNIQUE (ID_DATOTEKE_PLOVIL));

CREATE OR REPLACE
TRIGGER DATOTEKE_PLOVIL_TRG
BEFORE INSERT
ON DATOTEKE_PLOVIL
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
BEGIN
	IF (:NEW.ID_DATOTEKE_PLOVIL IS NULL) THEN
          SELECT DATOTEKE_PLOVIL_SEQ.NEXTVAL INTO :NEW.ID_DATOTEKE_PLOVIL FROM DUAL;;
	END IF;;
END;;
;

CREATE OR REPLACE VIEW V_DATOTEKE_PLOVIL AS (
	SELECT D.ID_DATOTEKE_PLOVIL, D.ZAPOREDNA, D.ID, D.DOKUMENT, D.DATOTEKA, D.TIP, D.GRUPA, 
	D.KOMENTAR, D.AVTOR, D.DATUM, D.USER_KREIRANJA, D.DATUM_KREIRANJA, D.USER_SPREMEMBE, D.DATUM_SPREMEMBE, D.STATUS, N.OPIS AS NNSTOFILTER_OPIS, P.IME AS PLOVILA_IME,
	NT.SIFRA AS NNTIPPRILOGE_SIFRA, NT.OPIS AS NNTIPPRILOGE_OPIS, D.ISSUER, D.DATEISSUE, CASE WHEN EXISTS (SELECT 1 FROM DATOTEKE_PLOVIL D2 WHERE D2.ID = D.ID AND D.ZAPOREDNA = 
  (SELECT MAX(D3.ZAPOREDNA) FROM DATOTEKE_PLOVIL D3 WHERE D3.ID = D.ID AND D3.DOCUMENTTYPE = D.DOCUMENTTYPE)) THEN 'Y' ELSE 'N' END AS LATEST_BY_DOCUMENTTYPE
	FROM DATOTEKE_PLOVIL D
	LEFT OUTER JOIN NNSTOFILTER N ON N.ID = D.GRUPA
	LEFT OUTER JOIN NNTIPPRILOGE NT ON NT.SIFRA = D.DOCUMENTTYPE
	LEFT OUTER JOIN PLOVILA P ON P.ID = D.ID
);

INSERT INTO NNEMAIL_TEMPLATE_TYPE(SIFRA, OPIS, INTERNI_OPIS, AKT) VALUES
('PUD', 'Portal upload document', 'Portal upload document', 'Y');

insert into verzije_baza (id, dt_vpis, verzija, ver_nr, opis) 
values 
(534, SYSDATE, '5.5', 454, 'Datoteke plovil');